#include "Data2SiloRecorder.hpp"
#include "Data2SiloRecorderUnit.hpp"

void Data2SiloRecorder::registerAttributes()
{
    CompoundEngine::registerAttributes();
    REGISTER_ATTRIBUTE(outputBase);
    REGISTER_ATTRIBUTE(interval);
}

Data2SiloRecorder::Data2SiloRecorder() : CompoundEngine(), outputFile()
{
    outputBase = "data";
    interval = 50;
}

bool Data2SiloRecorder::isActivated()
{
   return ((Omega::instance().getCurrentIteration() % interval == 0));
}

void Data2SiloRecorder::preaction()
{
    outputFile = outputBase+"_"+lexical_cast<string>( Omega::instance().getCurrentIteration() ) + ".silo";
} 

void Data2SiloRecorder::postaction()
{
   for (int i=0,iEnd = engines.size(); i<iEnd; ++i)
       engines[i]->action(0);
} 

//DBfile* Data2SiloRecorder::openSiloDB()
//{
//    DBfile *dbfile = DBCreate(outputFile.c_str(), DB_CLOBBER, DB_LOCAL, "", DB_HDF5);
//    if(dbfile==NULL)
//    {
//	std::cerr << "Could not create Silo file!" << std::endl;
//	return 0;
//    }
//    return dbfile;
//}
//
//void Data2SiloRecorder::closeSiloDB(DBfile* dbfile)
//{
//    DBClose(dbfile);
//}

void Data2SiloRecorder::postProcessAttributes(bool deserializing)
{
   if (!deserializing) return;

   for (int i=0,iEnd = engines.size(); i<iEnd; ++i)
   {
      Data2SiloRecorderUnit *e = dynamic_cast<Data2SiloRecorderUnit*>(engines[i].get());
      if (e) e->baseRecorder = shared_ptr<Data2SiloRecorder>(this);
      else cerr << "Bad Data2SiloRecorderUnit type" << endl;
   }
}

