#include "DynamicSpheres2SiloRecorder.hpp"
#include <yade/core/PhysicalParameters.hpp>
#include <yade/core/Omega.hpp>
#include <yade/core/MetaBody.hpp>
#include <boost/lexical_cast.hpp>

DynamicSpheres2SiloRecorder::DynamicSpheres2SiloRecorder () : Data2SiloRecorderUnit(), sphere(new Sphere), nbSpheres(0)
{
	meshName = "dynamicSpheresPositions";
	x.clear(); y.clear(); z.clear();
	vx.clear(); vy.clear(); vz.clear();
	radii.clear();
}


DynamicSpheres2SiloRecorder::~DynamicSpheres2SiloRecorder ()
{

}


void DynamicSpheres2SiloRecorder::postProcessAttributes(bool deserializing)
{
	if(deserializing)
	{
	//	
	}
}


void DynamicSpheres2SiloRecorder::registerAttributes()
{
	Data2SiloRecorderUnit::registerAttributes();
	REGISTER_ATTRIBUTE(meshName);
}


void DynamicSpheres2SiloRecorder::action(Body * b)
{
    if (b) {
	if (!b->isDynamic ||
	    b->geometricalModel->getClassIndex() != sphere->getClassIndex() ) return;

	const Sphere* s = static_cast<Sphere*>(b->geometricalModel.get());
	const ParticleParameters* p = static_cast<ParticleParameters*>(b->physicalParameters.get());
	radii.push_back(s->radius);
	x.push_back(p->se3.position[0]);
	y.push_back(p->se3.position[1]);
	z.push_back(p->se3.position[2]);
	vx.push_back(p->velocity[0]);
	vy.push_back(p->velocity[1]);
	vz.push_back(p->velocity[2]);
	nbSpheres++;
    } else {
//	DBfile* dbfile = baseRecorder->openSiloDB();
//	float *coords[] = {&x[0], &y[0], &z[0]};
//	float *velocities[] = {&vx[0], &vy[0], &vz[0]};
//	DBPutPointmesh(dbfile, meshName.c_str(), 3, coords, nbSpheres, DB_FLOAT, NULL);
//	DBPutPointvar1(dbfile, "radii", meshName.c_str(), &radii[0], nbSpheres, DB_FLOAT, NULL);
//	DBPutPointvar (dbfile, "velocities", meshName.c_str(), 3, velocities, nbSpheres, DB_FLOAT, NULL);
//	baseRecorder->closeSiloDB(dbfile);
    }
}

