#ifndef DYNAMICSPHERES2SILORECORDER_HPP
#define DYNAMICSPHERES2SILORECORDER_HPP

#include <yade/core/DataRecorder.hpp>
#include <yade/pkg-common/ParticleParameters.hpp>
#include <yade/pkg-common/Sphere.hpp>

#include "Data2SiloRecorder.hpp"
#include "Data2SiloRecorderUnit.hpp"

class DynamicSpheres2SiloRecorder : public Data2SiloRecorderUnit {
    private:
	shared_ptr<Sphere> sphere;
	std::vector<float> x,y,z; 
	std::vector<float> radii; 
	std::vector<float> vx,vy,vz; 
	int nbSpheres;

public :
    std::string meshName;

    DynamicSpheres2SiloRecorder();
    ~DynamicSpheres2SiloRecorder();

    virtual void action(Body* b);

protected :
    virtual void postProcessAttributes(bool deserializing);
    void registerAttributes();
    REGISTER_CLASS_NAME(DynamicSpheres2SiloRecorder);
    REGISTER_BASE_CLASS_NAME(Data2SiloRecorderUnit);
};
REGISTER_SERIALIZABLE(DynamicSpheres2SiloRecorder,false);

#endif // DYNAMICSPHERES2SILORECORDER_HPP

//#ifndef BOX2SILORECORDER_HPP
//#define BOX2SILORECORDER_HPP
//
//#include <yade/core/DataRecorder.hpp>
//#include <yade/pkg-common/RigidBodyParameters.hpp>
//#include <yade/pkg-common/Box.hpp>
//#include <string>
//
//class Box2SiloRecorder : public DataRecorder {
//    private:
//	shared_ptr<Box> box;
//
//public :
//    std::string outputFile;
//    std::string meshName;
//    unsigned int interval;
//
//    Box2SiloRecorder();
//    ~Box2SiloRecorder();
//
//    virtual void action(Body* b);
//
//protected :
//    virtual void postProcessAttributes(bool deserializing);
//    void registerAttributes();
//    REGISTER_CLASS_NAME(Box2SiloRecorder);
//    REGISTER_BASE_CLASS_NAME(DataRecorder);
//};
//REGISTER_SERIALIZABLE(Box2SiloRecorder,false);
//#endif // BOX2SILORECORDER_HPP
